#Include "windows.bi"
#Include "win/gdiplus.bi"
Using GDIPLUS
Dim wc As WNDCLASSEX
Dim  msg As MSG
Dim ULONG_PTR_01 As ULONG_PTR
Dim GDIPLUSSTARTUPINPUT_01 As GDIPLUSSTARTUPINPUT
GDIPLUSSTARTUPINPUT_01.GdiplusVersion = 1
If (GdiplusStartup(@ULONG_PTR_01, @GDIPLUSSTARTUPINPUT_01, NULL) <> 0) Then
	Print "FAIL"
EndIf
Sub OnPaint(compHdc As HDC)
	
	Dim As PVOID GpGraphics,Pen,Brush,Font,fontFamily
	Dim As GPRECTF Bound_
	Dim As UINT16 UI(3)={&h41,&h42,&h43,&h44} 'ABCD
   Dim As GPPointF positions(3)
   positions(0).x=100:positions(0).y=150
   positions(1).x=150:positions(1).y=200
   positions(2).x=300:positions(2).y=150
   positions(3).x=150:positions(3).y=100   
   
	GdipCreateFromHDC(compHdc,@GpGraphics)
	GdipGraphicsClear(GpGraphics,&hffffffff)
	GdipCreateSolidFill(&hFF000000,@Brush) 
	GdipCreatePen2(brush,1,UnitWorld,@pen) 
	GdipCreateFontFamilyFromName("Arial",NULL,@fontFamily)
   GdipCreateFont(fontFamily, 16, FontStyleRegular, UnitPoint, @font) 
   GdipMeasureDriverString(GpGraphics,@UI(0),-1,Font,@positions(0),DriverStringOptionsCmapLookup, NULL, @Bound_)
   GdipDrawRectangles(GpGraphics,pen, @bound_,1)
   GdipDrawDriverString(GpGraphics,@UI(0),-1,Font,brush, @positions(0),DriverStringOptionsCmapLookup,NULL)
	GdipDeleteBrush(Brush)
	GdipDeletePen(Pen)
	GdipDeleteFontFamily(fontFamily)
	GdipDeleteFont(font)
	GdipDeleteGraphics(GpGraphics)

End Sub
Function WndProc(hWnd As HWND,uMsg As UINT,wParam As WPARAM,lParam As LPARAM) As Integer
	Dim ps As PAINTSTRUCT
	Static As HDC compHdc,hdc
	Select Case uMsg
		Case WM_CLOSE
			DeleteDC(compHdc)
			PostQuitMessage(0)
		Case WM_CREATE
			hdc=GetDC(GetDesktopWindow)
			compHdc=CreateCompatibleDC(hdc)
			Var bitmap = CreateCompatibleBitmap(hdc,GetSystemMetrics(SM_CXSCREEN),GetSystemMetrics(SM_CYSCREEN))
			SelectObject(compHdc,bitmap)
			DeleteObject(bitmap)
			ReleaseDC(GetDesktopWindow,hdc)
			OnPaint(compHdc)
			InvalidateRect(hwnd,0,0)
		Case WM_PAINT
			BeginPaint(hWnd,@ps)
			BitBlt(ps.hdc,ps.rcPaint.left,ps.rcPaint.top,ps.rcPaint.right-ps.rcPaint.left,ps.rcPaint.bottom-ps.rcPaint.top,compHdc,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY)
			EndPaint(hWnd,@ps)
			Return 0
		Case Else
			Return DefWindowProc(hWnd,uMsg,wParam,lParam)
	End Select
End Function

With wc
	.hInstance=GetModuleHandle(0)
	.cbSize=SizeOf(WNDCLASSEX)
	.style=CS_HREDRAW Or CS_VREDRAW
	.lpfnWndProc=@WndProc
	.lpszClassName=StrPtr("class")
	.hCursor=LoadCursor(NULL,IDC_ARROW)
End With
RegisterClassEx(@wc)
CreateWindowEx(0,wc.lpszClassName,"DrawGDI+",WS_OVERLAPPEDWINDOW Or WS_VISIBLE,200,200,430,260,0,0,wc.hInstance,0)

While GetMessage(@msg,0,0,0)
	TranslateMessage(@msg)
	DispatchMessage(@msg)
Wend